module 'examples.sudoku' {
   main :-
      (
         'sys.cmdline':list([Arg])
      ->
         N = 'data.atom':number(Arg)
      ;
         N = 3
      ),
      Sudoku = this:create(N),
      'data.fd':labeling(Sudoku:list),
      print(Sudoku).

   create(N, Sudoku) :-
      Sudoku = 'data.array.backtrackable':new([1..N, 1..N, 1..N, 1..N]),
      'data.fd':set_domain(Sudoku:list, 1, 'data.number':(N * N)),
      'data.number':iter(1, N) [Sudoku, N] {
         do(I) :-
            'data.number':iter(1, N) [Sudoku, I, N] {
               do(J) :-
                  'data.fd':all_different(
                     Sudoku:slice([I, J, 1..N, 1..N]):list
                  ),
                  'data.fd':all_different(
                     Sudoku:slice([1..N, 1..N, I, J]):list
                  ),
                  'data.fd':all_different(
                     Sudoku:slice([I, 1..N, J, 1..N]):list
                  ).
            }.
      }.

   print(Sudoku) :-
      'data.list':iter(Sudoku:deep_list) {
         do(L) :-
            'data.list':iter(L) {
               do(L) :-
                  'data.list':iter(L) {
                     do(L) :-
                        'data.list':iter(L) {
                           do(V) :-
                              (
                                 'data.number':(V =< 9)
                              ->
                                 'io.std':print(V)
                              ;
                                 'data.number':(V =< 36)
                              ->
                                 'io.std':print(
                                    'data.number':char(
                                       'data.number':(V + 0'A - 10)
                                    )
                                 )
                              ;
                                 'io.std':print(
                                    'data.number':char(
                                       'data.number':(V + 0'a - 36)
                                    )
                                 )
                              ),
                              'io.std':print(' ').
                        },
                        'io.std':print(' ').
                  },
                  'io.std':endline.
            },
            'io.std':endline.
      }.
}
