module 'emop.writer' {
   callable(Term, P) :-
      'data.term':decomposition(Term, [F | Args]),
      P = callable(F, Args).

   condition(Cond, True, False) =
      callable(';', [callable('->', [Cond, True]), False]).

   sequence([]) = true.
   sequence([H | T]) =
      'data.list':fold_left(T, H) {
         do(I, S) = callable(',', [S, I]).
      }.

   write(S, P) :-
      module Writer [Writer, S, Output_char, Output_arg] {
         write(var(Var)) :-
            !,
            S:print('_'),
            (
               Var \= '_'
            ->
               S:print(Var)
            ;
               true
            ).
         write(callable(F, Args)) :-
            !,
            S:print('\''),
            'data.atom':string(F, Str),
            'data.list':iter(Str, Output_char),
            S:print('\''),
            Writer:write_args(Args).
         write(number(N)) :-
            !,
            S:print(N).
         write(T) :-
            throw(write(term(T))).

         write_args([]).
         write_args([H | T]) :-
            S:print('('),
            Writer:write(H),
            'data.list':iter(T, Output_arg),
            S:print(')').
         write_args(T) :-
            throw(write(args(T))).
      },
      module Output_char [S] {
         do(Char) :-
            'data.char':escape(Char, Escape),
            S:print(Escape).
      },
      module Output_arg [S, Writer] {
         do(Arg) :-
            S:print(', '),
            Writer:write(Arg).
      },
      Writer:write(P).

   write_clauses(S, C) :-
      module Write_clause [S] {
         do(Clause) :-
            catch(
               'emop.writer':write(S, Clause),
               E,
               throw(write(E, Clause))
            ),
            S:print_endline('.').
      },
      'data.list':iter(C, Write_clause).
}
